import entscheidungsbaum

# Beschreibung der Merkmale
merkmale = [
    ("Helligkeit", ["sehr dunkel", "eher hell"]),
    ("Größe", ["eher klein", "eher groß"])
]

# Pakete zum Lernen
lern_pakete = [
    ("eher hell", "eher klein", "nein"),
    ("sehr dunkel", "eher klein", "ja"),
    ("eher hell", "eher klein", "nein"),
    ("eher hell", "eher groß", "ja"),
    ("eher hell", "eher klein", "nein")]

# Anfänglicher Baum
baum = entscheidungsbaum.neuesNichtwissenBlatt()

durchlauf = 0
fehler = True

# Wiederhole bis alles richtig gelernt wurde
# aber maximal 5 Runden
while fehler and durchlauf < 5:
    durchlauf = durchlauf + 1
    fehler = False

    # Schleife über alle Lernbeispiele
    for paket in lern_pakete:
        klasse_des_pakets = paket[-1]

        # Beginne oben im Baum
        knoten = baum
        tiefe = 0

        # Steige anhand der Merkmale des Pakets
        # den Baum bis zu einem Blatt hinab
        while not knoten.istEinBlatt() and tiefe < \
                len(merkmale):
            knoten = knoten.kindFuerWert(paket[tiefe])
            tiefe = tiefe + 1

        # Keine Ahnung
        if knoten.istNichtwissenBlatt():
            knoten.setzeKlasse(klasse_des_pakets)
            fehler = True
        # Falsche Klasse
        elif not knoten.welcheKlasse() == \
                klasse_des_pakets:
            # weitere Merkmale vorhanden
            if tiefe < len(merkmale):
                merkmal_name, merkmal_werte = merkmale[tiefe]
                knoten.setzeAuswahlMerkmal(merkmal_name)

                # Knoten hinzufügen
                for wert in merkmal_werte:
                    if paket[tiefe] == wert:
                        blattFuerWert = \
                            entscheidungsbaum.neuesBlatt(\
                                klasse_des_pakets)
                    else:
                        blattFuerWert = \
                            entscheidungsbaum.neuesNichtwissenBlatt()
                    knoten.neuesKind(wert, blattFuerWert)
                fehler = True

            # keine weiteren Merkmale
            else:
                knoten.setzeKlasse(klasse_des_pakets)
                fehler = True

print(baum)

# Pakete zum Testen
test_pakete = [
    ("eher hell", "eher klein"),
    ("sehr dunkel", "eher groß"),
    ("eher hell", "eher klein"),
    ("sehr dunkel", "eher klein")]

# Schleife über alle Testbeispiele
for paket in test_pakete:
    # Beginne oben im Baum
    knoten = baum
    tiefe = 0

    # Steige anhand der Merkmale des Pakets
    # den Baum bis zu einem Blatt hinab
    while not knoten.istEinBlatt():
        knoten = knoten.kindFuerWert(paket[tiefe])
        tiefe = tiefe + 1

    # Entscheidung
    if knoten.istNichtwissenBlatt():
        geschenk_erwartet = "*"
    else:
        geschenk_erwartet = knoten.welcheKlasse()

    print(geschenk_erwartet)












