import tictactoe

def minimax(zustand):    
    gewonnen_mit = None
    unentschieden_mit = None
    verloren_mit = None
  
    for feld in zustand.freieFelder():
        naechsterZustand = zustand.besetzeFeld(feld)

        if naechsterZustand.spielBeendet():
            if naechsterZustand.O_hat_gewonnen():
                ergebnis = "gewonnen"
            elif naechsterZustand.unentschieden():
                ergebnis = "unentschieden"
            else:
                ergebnis = "verloren"
        else:
            ergebnis = spieler_zieht(naechsterZustand)
        
        if ergebnis == "gewonnen":
            gewonnen_mit = feld
        elif ergebnis == "unentschieden":
            unentschieden_mit = feld
        else:
            verloren_mit = feld
            
    if gewonnen_mit is not None:
        return "gewonnen", gewonnen_mit
    elif unentschieden_mit is not None:
        return "unentschieden", unentschieden_mit
    else:
        return "verloren", verloren_mit


def spieler_zieht(zustand):
    gewonnen_mit = None
    unentschieden_mit = None
    verloren_mit = None

    for feld in zustand.freieFelder():
        naechsterZustand = zustand.besetzeFeld(feld)
        
        if naechsterZustand.spielBeendet():
            if naechsterZustand.X_hat_gewonnen():
                ergebnis = "verloren"
            elif naechsterZustand.unentschieden():
                ergebnis = "unentschieden"
            else:
                ergebnis = "gewonnen"
        else:
            ergebnis, zug_computer = minimax(naechsterZustand)
            
        if ergebnis == "verloren":
            verloren_mit = feld
        elif ergebnis == "unentschieden":
            unentschieden_mit = feld
        else:
            gewonnen_mit = feld
            
    if verloren_mit is not None:
        return "verloren"
    elif unentschieden_mit is not None:
        return "unentschieden"
    else:
        return "gewonnen"
